var egMousePosX = 0;
var egMousePosY = 0;
var egContextMenuObject = null;
var egDropDownListBoxObject = null;

/**
*
* egWindow Functions
*/

function egWindow_getHeight() {
	 if(this.height <= 0) {
		div = document.getElementById(this.id);
		div.style.left = '-1000px';
		div.style.top = '-1000px';
		div.style.display = 'block';
		this.width  = div.offsetWidth;
		this.height = div.offsetHeight;
		div.style.display = 'none';
		div.style.left = this.x + 'px';
		div.style.top = this.y + 'px';
	 }
	 return this.height;
}

function egWindow_getWidth() {
	 if(this.width <= 0) {
		div = document.getElementById(this.id);
		div.style.left = '-1000px';
		div.style.top = '-1000px';
		div.style.display = 'block';
		this.width  = div.offsetWidth;
		this.height = div.offsetHeight;
		div.style.display = 'none';
		div.style.left = this.x + 'px';
		div.style.top = this.y + 'px';
	 }
	 return this.width;
}

function egWindow_show() {
	 div = document.getElementById(this.id);
	 div.style.display = 'block';
	 if(this.shadow) {
	 	this.shadow.show();
	 }
}

function egWindow_hide() {
	 div = document.getElementById(this.id);
	 div.style.display = 'none';
	 if(this.shadow) {
	 	this.shadow.hide();
	 }
}

function egWindow_moveTo(x,y) {
	 this.x = x;
	 this.y = y;
	 div = document.getElementById(this.id);
	 div.style.left = x + 'px';
	 div.style.top = y  + 'px';
}

function egWindow_displayAt(x,y) {
	 this.moveTo(x,y);
	 this.show();
}


/**
*
* egShadow Class
*/
function egShadow(object_id) {
	this.id = object_id + '_eg_shadow';
	this.parentId = object_id;
	this.width  = 0;
	this.height = 0;

	this.show = egShadow_show;
	this.hide = egShadow_hide;
	this.moveTo = egShadow_moveTo;
	this.setSize = egShadow_setSize;

	divRoot = document.getElementById('easy-GUI_mainLayer');

	divRoot.innerHTML += '<div id="'+this.id+'" class="eg_shadow">'
	 + '<div id="'+this.id+'_column_top" class="eg_shadow_column_top"></div>'
	 + '<div id="'+this.id+'_column_middle" class="eg_shadow_column_middle"></div>'
	 + '<div id="'+this.id+'_column_row" class="eg_shadow_column_row"></div>'
	 + '<div id="'+this.id+'_row_middle" class="eg_shadow_row_middle"></div>'
	 + '<div id="'+this.id+'_row_left" class="eg_shadow_row_left"></div>'
	 + '</div>';
}

function egShadow_show() {
	div = document.getElementById(this.id);
	divParent = document.getElementById(this.parentId);
	if(this.width <= 0) {
		this.setSize(divParent.offsetWidth, divParent.offsetHeight);
	}
	div.style.left = divParent.style.left;
	div.style.top  = divParent.style.top;
	div.style.display = 'block';
}

function egShadow_hide() {
	div = document.getElementById(this.id);
	div.style.display = 'none';
}

function egShadow_moveTo(x,y) {
	div = document.getElementById(this.id);
	div.style.left = x + 'px';
	div.style.top  = y + 'px';
}

function egShadow_setSize(width, height) {
	this.width  = width;
	this.height = height;

	div_sct = document.getElementById(this.id+'_column_top');
	div_scm = document.getElementById(this.id+'_column_middle');
	div_scr = document.getElementById(this.id+'_column_row');
	div_srm = document.getElementById(this.id+'_row_middle');
	div_srl = document.getElementById(this.id+'_row_left');

	div_scm.style.left = this.width + 'px';
	div_sct.style.left = this.width + 'px';
	div_sct.style.top  = '0px';
	div_scm.style.top  = '9px';

	div_scr.style.left = this.width + 'px';
	div_scr.style.top  = this.height + 'px';

	div_srm.style.top  = this.height + 'px';
	div_srl.style.top  = this.height + 'px';
	div_srm.style.left = '9px';
	div_srl.style.left = '0px';

	div_scm.style.height = (height-9) + 'px';
	div_srm.style.width = (width-9) + 'px';
}

/**
*
*	easy-GUI Utils
*/

function egGetClientHeight() {
	var easyCMS_clientHeight = 0;
	if( typeof( window.innerHeight ) == 'number' ) {
		/*Non-IE*/
		easyCMS_clientHeight = window.innerHeight;
	}
	else if( document.documentElement && document.documentElement.clientHeight ) {
		/*IE 6+ in 'standards compliant mode'*/
		easyCMS_clientHeight = document.documentElement.clientHeight;
	}
	else if( document.body && document.body.clientHeight ) {
		/*IE 4 compatible*/
		easyCMS_clientHeight = document.body.clientHeight;
	}
	return easyCMS_clientHeight;
}


function egGetClientWidth() {
	var easyCMS_clientWidth = 0;
	if( typeof( window.innerWidth ) == 'number' ) {
		/*Non-IE*/
		easyCMS_clientWidth = window.innerWidth;
	}
	else if( document.documentElement && document.documentElement.clientWidth ) {
		/*IE 6+ in 'standards compliant mode'*/
		easyCMS_clientWidth = document.documentElement.clientWidth;
	}
	else if( document.body && document.body.clientWidth ) {
		/*IE 4 compatible*/
		easyCMS_clientWidth = document.body.clientWidth;
	}
	return easyCMS_clientWidth;
}

function egGetAbsoluteLeft(objectId) {
	var o = document.getElementById(objectId);
	oLeft = o.offsetLeft;
	while(o.offsetParent!=null) { 
		oParent = o.offsetParent;
		oLeft += oParent.offsetLeft;
		o = oParent;
	}
	return oLeft;
}

function egGetAbsoluteTop(objectId) {
	var o = document.getElementById(objectId);
	var oTop = o.offsetTop;
	while(o.offsetParent!=null) {
		oParent = o.offsetParent;
		oTop += oParent.offsetTop;
		o = oParent;
	}
	return oTop;
}


function egGetScrollTop() {
  var scrOfY = 0;
  if( typeof( window.pageYOffset ) == 'number' ) {
    scrOfY = window.pageYOffset;
  }
	else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
    scrOfY = document.body.scrollTop;
  }
	else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
    scrOfY = document.documentElement.scrollTop;
  }
  return scrOfY;
}

function egGetScrollLeft() {
  var scrOfX = 0;
  if( typeof( window.pageYOffset ) == 'number' ) {
    scrOfX = window.pageXOffset;
  }
	else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
    scrOfX = document.body.scrollLeft;
  }
	else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
    scrOfX = document.documentElement.scrollLeft;
  }
  return scrOfX;
}

function egUpdateMouseX(e) {
	if (!e) {
		e = window.event;
	}
	if (e.pageX) {
		return e.pageX;
	}
	else {
		if (e.clientX) {
			return e.clientX + egGetScrollLeft();
		}
	}
	return 0;
}

function egUpdateMouseY(e) {
	if (!e) {
		e = window.event;
	}
	if (e.pageY) {
		return e.pageY;
	}
	else {
		if (e.clientY) {
			return e.clientY + egGetScrollTop();
		}
	}
	return 0;
}

function egUpdateMousePosition(e) {
	if (document.getElementById) {
		egMousePosX = parseInt(egUpdateMouseX(e));
		egMousePosY = parseInt(egUpdateMouseY(e));
	}
}


/**
*
*	functions related to objects management
*/

function egShowContextMenu(contextMenuObject){
	var posTop  = egMousePosY;
	var posLeft = egMousePosX;

	if(contextMenuObject) {
		if(egContextMenuObject) {
			egContextMenuObject.hide();
		}
		egContextMenuObject = contextMenuObject;

		if( (egGetClientWidth()-(egMousePosX-egGetScrollLeft())) < (contextMenuObject.getWidth()+20)) {
			posLeft = egMousePosX-contextMenuObject.getWidth();
		}
		if( (egGetClientHeight()-(egMousePosY-egGetScrollTop())) < (contextMenuObject.getHeight()+20)) {
			posTop = egMousePosY-contextMenuObject.getHeight();
		}
		contextMenuObject.displayAt(posLeft, posTop);
	}
}

function egHideContextMenu() {
	if(egContextMenuObject) {
		egContextMenuObject.hide();
		egContextMenuObject = null;
	}
}

function egHideDropDownListBox() {
	if(egDropDownListBoxObject) {
		egDropDownListBoxObject.hideList();
		egDropDownListBoxObject = null;
	}
}

function egShowToolTip(toolTipObject){

	var posTop  = egMousePosY;
	var posLeft = egMousePosX;

	if(toolTipObject) {

		if( (egGetClientWidth()-(egMousePosX-egGetScrollLeft())) < (toolTipObject.getWidth()+20)) {
			posLeft = egMousePosX-toolTipObject.getWidth();
		}
		if( (egGetClientHeight()-(egMousePosY-egGetScrollTop())) < (toolTipObject.getHeight()+20)) {
			posTop = egMousePosY-toolTipObject.getHeight();
		}
		toolTipObject.displayAt(posLeft, posTop);
	}
}


function egHideToolTip(toolTipObject){
	if(toolTipObject) {
		toolTipObject.hide();
	}
}

function egOnBodyMouseOver() {

}

function egOnBodyClick() {
  egHideContextMenu();
  egHideDropDownListBox();
}

function cancelBubble(newEvent) {
    if (document.all) {
        window.event.cancelBubble = true;
    } else {
        newEvent.cancelBubble = true;
    }
}


/**
*	Events handlers
*
*/

function egKeysHandler(e) {
	var key = (window.event)? window.event.keyCode : e.which;
	return true;
}

if (egBrowserType != 'IE') {
	document.captureEvents(Event.MOUSEMOVE);
}
document.onmousemove = egUpdateMousePosition;


if (egBrowserType != 'IE') {
	document.captureEvents(Event.KEYPRESS);
}
document.onkeypress = egKeysHandler;


/**
*	Dialog Window opening
*
*/
function openWindow(url, width, height, offsetX, offsetY) {
  var top  = ((screen.height-height)/2) + offsetX;
  var left = ((screen.width-width)/2) + offsetY;
  window.open(url,'','top='+top+',left='+left+',width='+width+',height='+height+',scrollbars=no,menubar=no,resizable=yes,toolbar=no,location=no,status=no');
}


/**
* A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
* Digest Algorithm, as defined in RFC 1321.
* Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
* Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
* Distributed under the BSD License
* See http://pajhome.org.uk/crypt/md5 for more info.
*/

/**
* Configurable variables. You may need to tweak these to be compatible with
* the server-side, but the defaults work in most cases.
*/
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */


/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_md5(s){ return binl2hex(core_md5(str2binl(s), s.length * chrsz));}
function b64_md5(s){ return binl2b64(core_md5(str2binl(s), s.length * chrsz));}
function str_md5(s){ return binl2str(core_md5(str2binl(s), s.length * chrsz));}
function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length
 */
function core_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Calculate the HMAC-MD5, of a key and some data
 */
function core_hmac_md5(key, data)
{
  var bkey = str2binl(key);
  if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
  return core_md5(opad.concat(hash), 512 + 128);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Convert a string to an array of little-endian words
 * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
 */
function str2binl(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz)
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
  return bin;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz)
    str += String.fromCharCode((bin[i>>5] >>> (i % 32)) & mask);
  return str;
}

/*
 * Convert an array of little-endian words to a hex string.
 */
function binl2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of little-endian words to a base-64 string
 */
function binl2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * ( i   %4)) & 0xFF) << 16)
                | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
                |  ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
      else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
    }
  }
  return str;
}